<template>
  <div class="fr-container fr-p-5w">
    <TheHeader
      :title="title"
      :back-link="backLink"
    >
      <template
        v-if="beneficiary"
        #title-extension
      >
        <ul class="fr-btns-group fr-btns-group--inline-md header-btn-group">
          <li>
            <NuxtLink
              :to="Routes.BeneficiaryEdit(beneficiaryId)"
              class="fr-btn fr-btn--tertiary-no-outline fr-icon-pencil-line"
              title="Modifier"
              target="_self"
            >
              Modifier
            </NuxtLink>
          </li>
          <li>
            <NuxtLink
              :to="Routes.BeneficiaryPrint(beneficiaryId)"
              class="fr-btn fr-btn--tertiary-no-outline fr-icon-printer-line"
              title="Imprimer"
              target="_self"
            >
              Imprimer
            </NuxtLink>
          </li>
          <li>
            <button
              v-if="canDeleteBeneficiaries"
              class="fr-btn fr-btn--tertiary-no-outline fr-icon-delete-line btn-delete-action"
              title="Supprimer"
              data-fr-opened="false"
              aria-controls="global-modal"
              type="button"
              @click="onDelete"
            >
              Supprimer
            </button>
          </li>
        </ul>
      </template>

      <template
        v-if="beneficiary"
        #subtitle
      >
        <ul class="beneficiary-file-details">
          <li>N° dossier : {{ readableFileNumber(beneficiary.id) }}</li>
          <li>Agent(s) référent(s) : {{ referents }}</li>
          <li
            v-if="beneficiary.aidant_connect_authorisation"
            class="fr-icon-success-line"
          >
            Mandat Aidant Connect
          </li>
        </ul>
      </template>
    </TheHeader>
    <div class="fr-grid-row fr-grid-row--gutters">
      <div class="fr-col-9">
        <main
          ref="tabsGroup"
          class="main-container fr-tabs"
        >
          <ul
            class="fr-tabs__list"
            role="tablist"
            aria-label="Fiche du bénéficiaire"
          >
            <li role="presentation">
              <button
                :id="tabId(BeneficiaryTab.Details)"
                class="fr-tabs__tab"
                tabindex="0"
                role="tab"
                aria-selected="false"
                :aria-controls="panel(BeneficiaryTab.Details)"
              >
                Infos
              </button>
            </li>
            <li role="presentation">
              <button
                :id="tabId(BeneficiaryTab.Documents)"
                class="fr-tabs__tab"
                tabindex="-1"
                role="tab"
                aria-selected="false"
                :aria-controls="panel(BeneficiaryTab.Documents)"
              >
                Documents
              </button>
            </li>
            <li role="presentation">
              <button
                :id="tabId(BeneficiaryTab.History)"
                class="fr-tabs__tab"
                tabindex="-1"
                role="tab"
                aria-selected="false"
                :aria-controls="panel(BeneficiaryTab.History)"
              >
                Historique
              </button>
            </li>
          </ul>
          <div
            :id="panel(BeneficiaryTab.Details)"
            class="fr-tabs__panel"
            role="tabpanel"
            :aria-labelledby="tabId(BeneficiaryTab.Details)"
            tabindex="0"
          >
            <AtomAlert
              v-if="error"
              :alert-type="AlertType.Error"
              message="Les informations du bénéficiaire n'ont pas pu être chargées."
            />

            <AtomLoader
              v-if="pending"
              class="fr-mx-auto"
            />
            <template v-else-if="beneficiary">
              <BeneficiaryDetails :beneficiary="beneficiary" />
              <ul
                class="fr-btns-group fr-btns-group--icon-left fr-btns-group--inline-md bottom-edit-btns"
              >
                <li>
                  <NuxtLink
                    :to="Routes.BeneficiaryEdit(beneficiaryId)"
                    class="fr-btn fr-btn--icon-left fr-icon-pencil-line"
                    target="_self"
                  >
                    Modifier la fiche du bénéficaire
                  </NuxtLink>
                </li>
                <li v-if="canDeleteBeneficiaries">
                  <button
                    class="fr-btn fr-icon-delete-line btn-delete-action"
                    data-fr-opened="false"
                    aria-controls="global-modal"
                    type="button"
                    @click="onDelete"
                  >
                    Supprimer la fiche du bénéficaire
                  </button>
                </li>
              </ul>

              <HistoryItem
                :id="beneficiaryId"
                class="fr-mt-4w"
              />
            </template>
          </div>
          <div
            :id="panel(BeneficiaryTab.Documents)"
            class="fr-tabs__panel"
            role="tabpanel"
            :aria-labelledby="tabId(BeneficiaryTab.Documents)"
            tabindex="0"
          >
            <BeneficiaryDocuments :beneficiary-id="beneficiaryId" />
          </div>
          <div
            :id="panel(BeneficiaryTab.History)"
            class="fr-tabs__panel"
            role="tabpanel"
            :aria-labelledby="tabId(BeneficiaryTab.History)"
            tabindex="0"
          >
            <BeneficiaryHistory :beneficiary-id="beneficiaryId" />
          </div>
        </main>
      </div>
      <div class="fr-col-3">
        <ul class="fr-btns-group fr-btns-group--icon-left">
          <li>
            <NuxtLink
              class="fr-btn fr-btn--icon-left fr-icon-file-add-line synthese-btn"
              :to="Routes.BeneficiaryInterviewsAdd(beneficiaryId)"
              target="_self"
            >
              Synthèse d'entretien
            </NuxtLink>
          </li>
          <li v-if="canAddHelpRequests">
            <NuxtLink
              class="fr-btn fr-btn--icon-left fr-icon-file-add-line demande-aide-btn"
              :to="Routes.BeneficiaryHelpRequestsAdd(beneficiaryId)"
              target="_self"
            >
              Demande d'aide
            </NuxtLink>
          </li>
          <li>
            <NuxtLink
              class="fr-btn fr-btn--icon-left fr-icon-team-line mes-droits-sociaux-btn"
              to="https://www.mesdroitssociaux.gouv.fr/dd1pnds-ria/#destination/simu-foyer"
              target="_blank"
            >
              Simulation de droits sociaux
            </NuxtLink>
          </li>
        </ul>
      </div>
    </div>
  </div>
</template>

<script setup>
  import { agentName, readableFileNumber } from '~/utils'
  import {
    ORIGIN_PAGE_PARAMETER,
    ORIGIN_TAB_PARAMETER
  } from '~/utils/constants'
  import { BeneficiaryTab } from '~/utils/constants/beneficiary-tabs'
  import { AlertType } from '~/utils/constants/alert'
  import { useBeneficiariesStore } from '~~/store/beneficiaries'
  import { getRandomId } from '~~/utils/random'
  import { beneficiaryName } from '~/utils/beneficiary'
  import { focusTab } from '~/utils/tab'
  import { usePermissionsStore } from '~/store/permissions'
  import { Routes } from '~/utils/routing/routes'
  import DeleteForm from '~/components/DeleteForm.vue'

  definePageMeta({ middleware: 'is-beneficiary-referent' })

  const INDEXED_TAB_IDS = [
    BeneficiaryTab.Details,
    BeneficiaryTab.Documents,
    BeneficiaryTab.History
  ]
  const { $loadBeneficiaryWithHistory, $modal, $snackbar } = useNuxtApp()
  const route = useRoute()
  const beneficiariesStore = useBeneficiariesStore()
  const permissionsStore = usePermissionsStore()

  const {
    data: beneficiary,
    pending,
    error
  } = useLazyAsyncData(getRandomId('beneficiary'), loadBeneficiary, {
    server: false
  })

  const tabsGroup = ref(null)
  const originPage = ref(null)
  const originTab = ref(null)

  const backLink = computed(() => {
    if (originPage.value) {
      const tabParam = originTab.value ? `?tab=${originTab.value}` : ''
      return `${originPage.value}${tabParam}`
    }
    return Routes.Beneficiaries
  })

  const title = computed(() => beneficiaryName(beneficiary.value || {}))

  const beneficiaryId = computed(() => route.params.id)

  const referents = computed(() =>
    beneficiary.value.referents
      .map(({ referent }) => agentName(referent))
      .join(', ')
  )

  const canAddHelpRequests = computed(() => permissionsStore.canAddHelpRequests)

  const canDeleteBeneficiaries = computed(
    () => permissionsStore.canDeleteBeneficiaries
  )

  onMounted(async () => {
    await nextTick()
    const { tab } = route.query
    if (tab) focusTab(tab, tabsGroup.value, INDEXED_TAB_IDS)
    else focusTab(BeneficiaryTab.Details, tabsGroup.value, INDEXED_TAB_IDS)

    initBacklinkParams()
    window.addEventListener('beforeprint', onPrint)
  })

  onBeforeUnmount(() => {
    window.removeEventListener('beforeprint', onPrint)
  })

  function initBacklinkParams() {
    const storeOriginPage = beneficiariesStore.originPage
    const storeOriginTab = beneficiariesStore.originTab

    if (route.query[ORIGIN_PAGE_PARAMETER]) {
      originPage.value = route.query[ORIGIN_PAGE_PARAMETER]
      originTab.value = route.query[ORIGIN_TAB_PARAMETER]
      beneficiariesStore.$patch({
        originPage: originPage.value,
        originTab: originTab.value
      })
    } else if (storeOriginPage) {
      originPage.value = storeOriginPage
      originTab.value = storeOriginTab
    }
  }

  async function loadBeneficiary() {
    return await $loadBeneficiaryWithHistory(beneficiaryId.value)
  }

  function tabId(tabName) {
    return `${tabName}-tab`
  }

  function panel(tabName) {
    return `${tabName}-panel`
  }

  function onPrint() {
    return navigateTo(Routes.BeneficiaryPrint(beneficiaryId.value))
  }

  function onDelete() {
    $modal.open(
      'Supprimer la fiche bénéficiaire',
      DeleteForm,
      {
        itemId: beneficiaryId.value,
        collection: 'beneficiary',
        detailedMessage:
          "L'ensemble des éléments relatifs au bénéficiaire (informations, historique, documents, statistiques) seront définitivement supprimés."
      },
      { deleted: onBeneficiaryDeleted }
    )
  }

  function onBeneficiaryDeleted() {
    navigateTo(backLink.value)
    $snackbar.success('Le bénéficiaire a été supprimé.')
  }
</script>

<style lang="scss" scoped>
  @use '@gouvfr/dsfr/src/core/index' as dsfr;

  .beneficiary-file-details {
    @include dsfr.disable-list-style;

    font-weight: 700;
    margin-top: 0.5rem;
  }

  .bottom-edit-btns {
    display: flex;
    margin-left: auto;
    margin-top: 3rem;
    width: fit-content;
  }

  .fr-btns-group {
    position: sticky;
    top: 2rem;

    .fr-btn {
      justify-content: flex-start;
    }
  }

  .mes-droits-sociaux-btn {
    border-radius: 2rem;
  }

  .mes-droits-sociaux-btn:hover {
    background-color: --color-mes-droits-sociaux-hover;
  }

  .synthese-btn {
    background-color: var(--color-interview);
  }

  .synthese-btn:hover {
    background-color: var(--color-interview-hover);
  }

  .demande-aide-btn {
    background-color: var(--color-help-request);
  }

  .demande-aide-btn:hover {
    background-color: var(--color-help-request-hover);
  }

  .header-btn-group.fr-btns-group {
    display: inline-flex;

    .fr-btn {
      margin-bottom: 0;
    }
  }
</style>
